unit Test;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  ComObj, ActiveX, Project1_TLB, StdVcl;

type
  TTest = class(TAutoObject, ITest)
  private
    FMessage: string;
  protected
    constructor Create(Message: string);
    function Get_Message: WideString; safecall;
    procedure Set_Message(const Value: WideString); safecall;
  end;

implementation

uses ComServ;

type
  // Fabrique de classe pour TTest
  TTestFactory = class(TAutoObjectFactory, ITestFactory)
  protected
    function CreateTest(const Message: WideString): ITest; safecall;
  end;


// Mthodes de TTest

constructor TTest.Create(Message: string);
begin
  inherited Create;
  FMessage := Message;
end;

function TTest.Get_Message: WideString;
begin
  Result := FMessage;
end;

procedure TTest.Set_Message(const Value: WideString);
begin
  FMessage := Value;
end;


// Mthode de TTestFactory

function TTestFactory.CreateTest(const Message: WideString): ITest;
begin
  Result := TTest.Create(Message) as ITest;
end;

initialization
  //  On a remplac TAutoObjectFactory par TTestFactory
  TTestFactory.Create(ComServer, TTest, Class_Test, ciMultiInstance, tmApartment);

end.
